diff --git a/rsvg-cairo-draw.c b/rsvg-cairo-draw.c
index 6c71a60..f100d9f 100644
--- a/rsvg-cairo-draw.c
+++ b/rsvg-cairo-draw.c
@@ -621,143 +539,79 @@ rsvg_cairo_render_path (RsvgDrawingCtx * ctx, const RsvgBpathDef * bpath_def)
 
     if (state->stroke != NULL) {
         int opacity;
-        if (!need_tmpbuf)
-            opacity = (state->stroke_opacity * state->opacity) / 255;
-        else
-            opacity = state->stroke_opacity;
+        opacity = state->stroke_opacity;
 
         _set_source_rsvg_paint_server (ctx,
                                        state->current_color,
                                        state->stroke,
-                                       opacity, bbox, rsvg_state_current (ctx)->current_color);
+                                       opacity, bbox, rsvg_current_state (ctx)->current_color);
 
         cairo_stroke (cr);
     }
 
-    if (need_tmpbuf)
-        rsvg_cairo_pop_discrete_layer (ctx);
+    cairo_new_path (cr); /* clear the path in case stroke == fill == NULL; otherwise we leave it around from computing the bounding box */
+
+    rsvg_cairo_pop_discrete_layer (ctx);
 }
 
 void
-rsvg_cairo_render_image (RsvgDrawingCtx * ctx, const GdkPixbuf * pixbuf,
-                         double pixbuf_x, double pixbuf_y, double w, double h)
+rsvg_cairo_render_surface (RsvgDrawingCtx *ctx, 
+                           cairo_surface_t *surface,
+                           double src_x, 
+                           double src_y, 
+                           double w, 
+                           double h)
 {
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
-    RsvgState *state = rsvg_state_current (ctx);
-
-    gint width = gdk_pixbuf_get_width (pixbuf);
-    gint height = gdk_pixbuf_get_height (pixbuf);
-    double dwidth = width, dheight = height;
-    guchar *gdk_pixels = gdk_pixbuf_get_pixels (pixbuf);
-    int gdk_rowstride = gdk_pixbuf_get_rowstride (pixbuf);
-    int n_channels = gdk_pixbuf_get_n_channels (pixbuf);
-    guchar *cairo_pixels;
-    cairo_format_t format;
-    cairo_surface_t *surface;
-    static const cairo_user_data_key_t key;
-    int j;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
+    RsvgState *state = rsvg_current_state (ctx);
+
+    int width, height;
+    double dwidth, dheight;
     RsvgBbox bbox;
 
-    if (pixbuf == NULL)
+    if (surface == NULL)
         return;
 
-    rsvg_bbox_init (&bbox, state->affine);
-    bbox.x = pixbuf_x;
-    bbox.y = pixbuf_y;
-    bbox.w = w;
-    bbox.h = h;
-    bbox.virgin = 0;
-
-    _set_rsvg_affine (render, state->affine);
-    cairo_scale (render->cr, w / dwidth, h / dheight);
-    pixbuf_x *= dwidth / w;
-    pixbuf_y *= dheight / h;
-
-    if (n_channels == 3)
-        format = CAIRO_FORMAT_RGB24;
-    else
-        format = CAIRO_FORMAT_ARGB32;
-
-    cairo_pixels = g_try_malloc (4 * width * height);
-	if (!cairo_pixels)
-		return;
-
-    surface = cairo_image_surface_create_for_data ((unsigned char *) cairo_pixels,
-                                                   format, width, height, 4 * width);
-    cairo_surface_set_user_data (surface, &key, cairo_pixels, (cairo_destroy_func_t) g_free);
-
-    for (j = height; j; j--) {
-        guchar *p = gdk_pixels;
-        guchar *q = cairo_pixels;
-
-        if (n_channels == 3) {
-            guchar *end = p + 3 * width;
-
-            while (p < end) {
-#if G_BYTE_ORDER == G_LITTLE_ENDIAN
-                q[0] = p[2];
-                q[1] = p[1];
-                q[2] = p[0];
-#else
-                q[1] = p[0];
-                q[2] = p[1];
-                q[3] = p[2];
-#endif
-                p += 3;
-                q += 4;
-            }
-        } else {
-            guchar *end = p + 4 * width;
-            guint t1, t2, t3;
-
-#define MULT(d,c,a,t) G_STMT_START { t = c * a + 0x7f; d = ((t >> 8) + t) >> 8; } G_STMT_END
+    g_return_if_fail (cairo_surface_get_type (surface) == CAIRO_SURFACE_TYPE_IMAGE);
 
-            while (p < end) {
-#if G_BYTE_ORDER == G_LITTLE_ENDIAN
-                MULT (q[0], p[2], p[3], t1);
-                MULT (q[1], p[1], p[3], t2);
-                MULT (q[2], p[0], p[3], t3);
-                q[3] = p[3];
-#else
-                q[0] = p[3];
-                MULT (q[1], p[0], p[3], t1);
-                MULT (q[2], p[1], p[3], t2);
-                MULT (q[3], p[2], p[3], t3);
-#endif
-
-                p += 4;
-                q += 4;
-            }
+    dwidth = width = cairo_image_surface_get_width (surface);
+    dheight = height = cairo_image_surface_get_height (surface);
+    if (width == 0 || height == 0)
+        return;
 
-#undef MULT
-        }
+    rsvg_bbox_init (&bbox, &state->affine);
+    bbox.rect.x = src_x;
+    bbox.rect.y = src_y;
+    bbox.rect.width = w;
+    bbox.rect.height = h;
+    bbox.virgin = 0;
 
-        gdk_pixels += gdk_rowstride;
-        cairo_pixels += 4 * width;
-    }
+    _set_rsvg_affine (render, &state->affine);
+    cairo_scale (render->cr, w / dwidth, h / dheight);
+    src_x *= dwidth / w;
+    src_y *= dheight / h;
 
-    _rsvg_cairo_set_operator (render->cr, state->comp_op);
+    cairo_set_operator (render->cr, state->comp_op);
 
 #if 1
-    cairo_set_source_surface (render->cr, surface, pixbuf_x, pixbuf_y);
+    cairo_set_source_surface (render->cr, surface, src_x, src_y);
 #else
-	{
-		cairo_pattern_t *pattern;
-		cairo_matrix_t matrix;
+    {
+        cairo_pattern_t *pattern;
+        cairo_matrix_t matrix;
 
-		pattern = cairo_pattern_create_for_surface (surface);
-		cairo_pattern_set_extend (pattern, CAIRO_EXTEND_PAD);
+        pattern = cairo_pattern_create_for_surface (surface);
+        cairo_pattern_set_extend (pattern, CAIRO_EXTEND_PAD);
 
-		cairo_matrix_init_translate (&matrix, -pixbuf_x, -pixbuf_y);
-		cairo_pattern_set_matrix (pattern, &matrix);
+        cairo_matrix_init_translate (&matrix, -src_x, -src_y);
+        cairo_pattern_set_matrix (pattern, &matrix);
 
-		cairo_set_source (render->cr, pattern);
-		cairo_pattern_destroy (pattern);
-	}
+        cairo_set_source (render->cr, pattern);
+        cairo_pattern_destroy (pattern);
+    }
 #endif
 
     cairo_paint (render->cr);
-    cairo_surface_destroy (surface);
 
     rsvg_bbox_insert (&render->bbox, &bbox);
 }
@@ -765,17 +619,26 @@ rsvg_cairo_render_image (RsvgDrawingCtx * ctx, const GdkPixbuf * pixbuf,
 static void
 rsvg_cairo_generate_mask (cairo_t * cr, RsvgMask * self, RsvgDrawingCtx * ctx, RsvgBbox * bbox)
 {
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
     cairo_surface_t *surface;
     cairo_t *mask_cr, *save_cr;
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
-    RsvgState *state = rsvg_state_current (ctx);
+    RsvgState *state = rsvg_current_state (ctx);
     guint8 *pixels;
     guint32 width = render->width, height = render->height;
     guint32 rowstride = width * 4, row, i;
-    double affinesave[6];
+    cairo_matrix_t affinesave;
     double sx, sy, sw, sh;
     gboolean nest = cr != render->initial_cr;
 
+    surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
+    if (cairo_surface_status (surface) != CAIRO_STATUS_SUCCESS) {
+        cairo_surface_destroy (surface);
+        return;
+    }
+
+    pixels = cairo_image_surface_get_data (surface);
+    rowstride = cairo_image_surface_get_stride (surface);
+
     if (self->maskunits == objectBoundingBox)
         _rsvg_push_view_box (ctx, 1, 1);
 
@@ -787,33 +650,31 @@ rsvg_cairo_generate_mask (cairo_t * cr, RsvgMask * self, RsvgDrawingCtx * ctx, R
     if (self->maskunits == objectBoundingBox)
         _rsvg_pop_view_box (ctx);
 
-    pixels = g_new0 (guint8, height * rowstride);
-    surface = cairo_image_surface_create_for_data (pixels,
-                                                   CAIRO_FORMAT_ARGB32, width, height, rowstride);
-
     mask_cr = cairo_create (surface);
     save_cr = render->cr;
     render->cr = mask_cr;
 
     if (self->maskunits == objectBoundingBox)
         rsvg_cairo_add_clipping_rect (ctx,
-                                      sx * bbox->w + bbox->x,
-                                      sy * bbox->h + bbox->y, sw * bbox->w, sh * bbox->h);
+                                      sx * bbox->rect.width + bbox->rect.x,
+                                      sy * bbox->rect.height + bbox->rect.y,
+                                      sw * bbox->rect.width,
+                                      sh * bbox->rect.height);
     else
         rsvg_cairo_add_clipping_rect (ctx, sx, sy, sw, sh);
 
     /* Horribly dirty hack to have the bbox premultiplied to everything */
     if (self->contentunits == objectBoundingBox) {
-        double bbtransform[6];
-        bbtransform[0] = bbox->w;
-        bbtransform[1] = 0.;
-        bbtransform[2] = 0.;
-        bbtransform[3] = bbox->h;
-        bbtransform[4] = bbox->x;
-        bbtransform[5] = bbox->y;
-        for (i = 0; i < 6; i++)
-            affinesave[i] = self->super.state->affine[i];
-        _rsvg_affine_multiply (self->super.state->affine, bbtransform, self->super.state->affine);
+        cairo_matrix_t bbtransform;
+        cairo_matrix_init (&bbtransform,
+                           bbox->rect.width,
+                           0,
+                           0,
+                           bbox->rect.height,
+                           bbox->rect.x,
+                           bbox->rect.y);
+        affinesave = self->super.state->affine;
+        cairo_matrix_multiply (&self->super.state->affine, &bbtransform, &self->super.state->affine);
         _rsvg_push_view_box (ctx, 1, 1);
     }
 
@@ -823,8 +684,7 @@ rsvg_cairo_generate_mask (cairo_t * cr, RsvgMask * self, RsvgDrawingCtx * ctx, R
 
     if (self->contentunits == objectBoundingBox) {
         _rsvg_pop_view_box (ctx);
-        for (i = 0; i < 6; i++)
-            self->super.state->affine[i] = affinesave[i];
+        self->super.state->affine = affinesave;
     }
 
     render->cr = save_cr;
@@ -846,63 +706,66 @@ rsvg_cairo_generate_mask (cairo_t * cr, RsvgMask * self, RsvgDrawingCtx * ctx, R
                         nest ? 0 : render->offset_x,
                         nest ? 0 : render->offset_y);
     cairo_surface_destroy (surface);
-    g_free (pixels);
-}
-
-static void
-rsvg_cairo_push_early_clips (RsvgDrawingCtx * ctx)
-{
-    cairo_save (((RsvgCairoRender *) ctx->render)->cr);
-    if (rsvg_state_current (ctx)->clip_path_ref)
-        if (((RsvgClipPath *) rsvg_state_current (ctx)->clip_path_ref)->units == userSpaceOnUse)
-            rsvg_cairo_clip (ctx, rsvg_state_current (ctx)->clip_path_ref, NULL);
-
 }
 
 static void
 rsvg_cairo_push_render_stack (RsvgDrawingCtx * ctx)
 {
-    /* XXX: Untested, probably needs help wrt filters */
-
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
     cairo_surface_t *surface;
     cairo_t *child_cr;
     RsvgBbox *bbox;
-    RsvgState *state = rsvg_state_current (ctx);
+    RsvgState *state = rsvg_current_state (ctx);
     gboolean lateclip = FALSE;
 
-    if (rsvg_state_current (ctx)->clip_path_ref)
-        if (((RsvgClipPath *) rsvg_state_current (ctx)->clip_path_ref)->units == objectBoundingBox)
-            lateclip = TRUE;
+    if (rsvg_current_state (ctx)->clip_path) {
+        RsvgNode *node;
+        node = rsvg_acquire_node (ctx, rsvg_current_state (ctx)->clip_path);
+        if (node && RSVG_NODE_TYPE (node) == RSVG_NODE_TYPE_CLIP_PATH) {
+            RsvgClipPath *clip_path = (RsvgClipPath *) node;
+
+            switch (clip_path->units) {
+            case userSpaceOnUse:
+                rsvg_cairo_clip (ctx, clip_path, NULL);
+                break;
+            case objectBoundingBox:
+                lateclip = TRUE;
+                break;
+
+            default:
+                g_assert_not_reached ();
+                break;
+            }
+
+        }
+        
+        rsvg_release_node (ctx, node);
+    }
 
     if (state->opacity == 0xFF
-        && !state->filter && !state->mask && !lateclip && (state->comp_op == RSVG_COMP_OP_SRC_OVER)
+        && !state->filter && !state->mask && !lateclip && (state->comp_op == CAIRO_OPERATOR_OVER)
         && (state->enable_background == RSVG_ENABLE_BACKGROUND_ACCUMULATE))
         return;
-    if (!state->filter)
+
+    if (!state->filter) {
         surface = cairo_surface_create_similar (cairo_get_target (render->cr),
                                                 CAIRO_CONTENT_COLOR_ALPHA,
                                                 render->width, render->height);
-    else {
-        guchar *pixels;
-        int rowstride = render->width * 4;
-        pixels = g_new0 (guint8, render->width * render->height * 4);
-
-        surface = cairo_image_surface_create_for_data (pixels,
-                                                       CAIRO_FORMAT_ARGB32,
-                                                       render->width, render->height, rowstride);
-        render->pixbuf_stack =
-            g_list_prepend (render->pixbuf_stack,
-                            gdk_pixbuf_new_from_data (pixels,
-                                                      GDK_COLORSPACE_RGB,
-                                                      TRUE,
-                                                      8,
-                                                      render->width,
-                                                      render->height,
-                                                      rowstride,
-                                                      (GdkPixbufDestroyNotify) rsvg_pixmap_destroy,
-                                                      NULL));
+    } else {
+        surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 
+                                              render->width, render->height);
+
+        /* The surface reference is owned by the child_cr created below and put on the cr_stack! */
+        render->surfaces_stack = g_list_prepend (render->surfaces_stack, surface);
+    }
+
+#if 0
+    if (cairo_surface_status (surface) != CAIRO_STATUS_SUCCESS) {
+        cairo_surface_destroy (surface);
+        return;
     }
+#endif
+
     child_cr = cairo_create (surface);
     cairo_surface_destroy (surface);
 
@@ -912,91 +775,61 @@ rsvg_cairo_push_render_stack (RsvgDrawingCtx * ctx)
     bbox = g_new (RsvgBbox, 1);
     *bbox = render->bbox;
     render->bb_stack = g_list_prepend (render->bb_stack, bbox);
-    rsvg_bbox_init (&render->bbox, state->affine);
+    rsvg_bbox_init (&render->bbox, &state->affine);
 }
 
 void
 rsvg_cairo_push_discrete_layer (RsvgDrawingCtx * ctx)
 {
-    rsvg_cairo_push_early_clips (ctx);
-    rsvg_cairo_push_render_stack (ctx);
-}
-
-static GdkPixbuf *
-rsvg_compile_bg (RsvgDrawingCtx * ctx)
-{
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
-    cairo_t *cr;
-    cairo_surface_t *surface;
-    GList *i;
-    unsigned char *pixels = g_new0 (guint8, render->width * render->height * 4);
-    int rowstride = render->width * 4;
-
-    GdkPixbuf *output = gdk_pixbuf_new_from_data (pixels,
-                                                  GDK_COLORSPACE_RGB, TRUE, 8,
-                                                  render->width, render->height,
-                                                  rowstride,
-                                                  (GdkPixbufDestroyNotify) rsvg_pixmap_destroy,
-                                                  NULL);
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
 
-    surface = cairo_image_surface_create_for_data (pixels,
-                                                   CAIRO_FORMAT_ARGB32,
-                                                   render->width, render->height, rowstride);
-
-    cr = cairo_create (surface);
-    cairo_surface_destroy (surface);
-
-    for (i = g_list_last (render->cr_stack); i != NULL; i = g_list_previous (i)) {
-        cairo_t *draw = i->data;
-        gboolean nest = draw != render->initial_cr;
-        cairo_set_source_surface (cr, cairo_get_target (draw),
-                                  nest ? 0 : -render->offset_x,
-                                  nest ? 0 : -render->offset_y);
-        cairo_paint (cr);
-    }
-
-    cairo_destroy (cr);
-    return output;
+    cairo_save (render->cr);
+    rsvg_cairo_push_render_stack (ctx);
 }
 
 static void
 rsvg_cairo_pop_render_stack (RsvgDrawingCtx * ctx)
 {
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
     cairo_t *child_cr = render->cr;
-    gboolean lateclip = FALSE;
-    GdkPixbuf *output = NULL;
+    RsvgClipPath *lateclip = NULL;
     cairo_surface_t *surface = NULL;
-    RsvgState *state = rsvg_state_current (ctx);
-    gboolean nest;
-
-    if (rsvg_state_current (ctx)->clip_path_ref)
-        if (((RsvgClipPath *) rsvg_state_current (ctx)->clip_path_ref)->units == objectBoundingBox)
-            lateclip = TRUE;
+    RsvgState *state = rsvg_current_state (ctx);
+    gboolean nest, needs_destroy = FALSE;
+
+    if (rsvg_current_state (ctx)->clip_path) {
+        RsvgNode *node;
+        node = rsvg_acquire_node (ctx, rsvg_current_state (ctx)->clip_path);
+        if (node && RSVG_NODE_TYPE (node) == RSVG_NODE_TYPE_CLIP_PATH
+            && ((RsvgClipPath *) node)->units == objectBoundingBox)
+            lateclip = (RsvgClipPath *) node;
+        else
+            rsvg_release_node (ctx, node);
+    }
 
     if (state->opacity == 0xFF
-        && !state->filter && !state->mask && !lateclip && (state->comp_op == RSVG_COMP_OP_SRC_OVER)
+        && !state->filter && !state->mask && !lateclip && (state->comp_op == CAIRO_OPERATOR_OVER)
         && (state->enable_background == RSVG_ENABLE_BACKGROUND_ACCUMULATE))
         return;
 
-    if (state->filter) {
-        GdkPixbuf *pixbuf = render->pixbuf_stack->data;
-        GdkPixbuf *bg = rsvg_compile_bg (ctx);
+    surface = cairo_get_target (child_cr);
 
-        render->pixbuf_stack = g_list_remove (render->pixbuf_stack, pixbuf);
+    if (state->filter) {
+        RsvgNode *filter;
+        cairo_surface_t *output;
 
+        filter = rsvg_acquire_node (ctx, state->filter);
+        output = render->surfaces_stack->data;
+        render->surfaces_stack = g_list_delete_link (render->surfaces_stack, render->surfaces_stack);
 
-        output = rsvg_filter_render (state->filter, pixbuf, bg, ctx, &render->bbox, "2103");
-        g_object_unref (G_OBJECT (pixbuf));
-        g_object_unref (G_OBJECT (bg));
+        if (filter && RSVG_NODE_TYPE (filter) == RSVG_NODE_TYPE_FILTER) {
+            needs_destroy = TRUE;
+            surface = rsvg_filter_render ((RsvgFilter *) filter, output, ctx, &render->bbox, "2103");
+            /* Don't destroy the output surface, it's owned by child_cr */
+        }
 
-        surface = cairo_image_surface_create_for_data (gdk_pixbuf_get_pixels (output),
-                                                       CAIRO_FORMAT_ARGB32,
-                                                       gdk_pixbuf_get_width (output),
-                                                       gdk_pixbuf_get_height (output),
-                                                       gdk_pixbuf_get_rowstride (output));
-    } else
-        surface = cairo_get_target (child_cr);
+        rsvg_release_node (ctx, filter);
+    }
 
     render->cr = (cairo_t *) render->cr_stack->data;
     render->cr_stack = g_list_delete_link (render->cr_stack, render->cr_stack);
@@ -1007,19 +840,26 @@ rsvg_cairo_pop_render_stack (RsvgDrawingCtx * ctx)
                               nest ? 0 : render->offset_x,
                               nest ? 0 : render->offset_y);
 
-    if (lateclip)
-        rsvg_cairo_clip (ctx, rsvg_state_current (ctx)->clip_path_ref, &render->bbox);
+    if (lateclip) {
+        rsvg_cairo_clip (ctx, lateclip, &render->bbox);
+        rsvg_release_node (ctx, (RsvgNode *) lateclip);
+    }
 
-    _rsvg_cairo_set_operator (render->cr, state->comp_op);
+    cairo_set_operator (render->cr, state->comp_op);
 
     if (state->mask) {
-        rsvg_cairo_generate_mask (render->cr, state->mask, ctx, &render->bbox);
+        RsvgNode *mask;
+
+        mask = rsvg_acquire_node (ctx, state->mask);
+        if (mask && RSVG_NODE_TYPE (mask) == RSVG_NODE_TYPE_MASK)
+          rsvg_cairo_generate_mask (render->cr, (RsvgMask *) mask, ctx, &render->bbox);
+        rsvg_release_node (ctx, mask);
     } else if (state->opacity != 0xFF)
         cairo_paint_with_alpha (render->cr, (double) state->opacity / 255.0);
     else
         cairo_paint (render->cr);
-    cairo_destroy (child_cr);
 
+    cairo_destroy (child_cr);
 
     rsvg_bbox_insert ((RsvgBbox *) render->bb_stack->data, &render->bbox);
 
@@ -1028,8 +868,7 @@ rsvg_cairo_pop_render_stack (RsvgDrawingCtx * ctx)
     g_free (render->bb_stack->data);
     render->bb_stack = g_list_delete_link (render->bb_stack, render->bb_stack);
 
-    if (state->filter) {
-        g_object_unref (G_OBJECT (output));
+    if (needs_destroy) {
         cairo_surface_destroy (surface);
     }
 }
@@ -1037,43 +876,43 @@ rsvg_cairo_pop_render_stack (RsvgDrawingCtx * ctx)
 void
 rsvg_cairo_pop_discrete_layer (RsvgDrawingCtx * ctx)
 {
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
+
     rsvg_cairo_pop_render_stack (ctx);
-    cairo_restore (((RsvgCairoRender *) ctx->render)->cr);
+    cairo_restore (render->cr);
 }
 
 void
 rsvg_cairo_add_clipping_rect (RsvgDrawingCtx * ctx, double x, double y, double w, double h)
 {
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
     cairo_t *cr = render->cr;
 
-    _set_rsvg_affine (render, rsvg_state_current (ctx)->affine);
+    _set_rsvg_affine (render, &rsvg_current_state (ctx)->affine);
 
     cairo_rectangle (cr, x, y, w, h);
     cairo_clip (cr);
 }
 
-GdkPixbuf *
-rsvg_cairo_get_image_of_node (RsvgDrawingCtx * ctx,
-                              RsvgNode * drawable, double width, double height)
+cairo_surface_t *
+rsvg_cairo_get_surface_of_node (RsvgDrawingCtx *ctx,
+                                RsvgNode *drawable, 
+                                double width, 
+                                double height)
 {
-    /* XXX: untested, should work */
-
-    GdkPixbuf *img = NULL;
     cairo_surface_t *surface;
     cairo_t *cr;
-    guint8 *pixels;
-    int rowstride;
 
     RsvgCairoRender *save_render = (RsvgCairoRender *) ctx->render;
     RsvgCairoRender *render;
 
-    rowstride = width * 4;
-    pixels = g_new0 (guint8, width * height * 4);
-    surface = cairo_image_surface_create_for_data (pixels,
-                                                   CAIRO_FORMAT_ARGB32, width, height, rowstride);
+    surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
+    if (cairo_surface_status (surface) != CAIRO_STATUS_SUCCESS) {
+        cairo_surface_destroy (surface);
+        return NULL;
+    }
+
     cr = cairo_create (surface);
-    cairo_surface_destroy (surface);
 
     render = rsvg_cairo_render_new (cr, width, height);
     ctx->render = (RsvgRender *) render;
@@ -1082,24 +921,221 @@ rsvg_cairo_get_image_of_node (RsvgDrawingCtx * ctx,
     rsvg_node_draw (drawable, ctx, 0);
     rsvg_state_pop (ctx);
 
-	/* no colorspace conversion necessary. this is just a convenient
-	   holder of ARGB data with a width, height, & stride */
-    img = gdk_pixbuf_new_from_data (pixels,
-                                    GDK_COLORSPACE_RGB,
-                                    TRUE,
-                                    8,
-                                    width,
-                                    height,
-                                    rowstride, (GdkPixbufDestroyNotify) rsvg_pixmap_destroy, NULL);
-
     cairo_destroy (cr);
 
     rsvg_render_free (ctx->render);
     ctx->render = (RsvgRender *) save_render;
 
-    return img;
+    return surface;
 }
 
+cairo_surface_t *
+rsvg_cairo_surface_from_pixbuf (const GdkPixbuf *pixbuf)
+{
+    gint width, height, gdk_rowstride, n_channels, cairo_rowstride;
+    guchar *gdk_pixels, *cairo_pixels;
+    cairo_format_t format;
+    cairo_surface_t *surface;
+    int j;
+
+    if (pixbuf == NULL)
+        return NULL;
+
+    width = gdk_pixbuf_get_width (pixbuf);
+    height = gdk_pixbuf_get_height (pixbuf);
+    gdk_pixels = gdk_pixbuf_get_pixels (pixbuf);
+    gdk_rowstride = gdk_pixbuf_get_rowstride (pixbuf);
+    n_channels = gdk_pixbuf_get_n_channels (pixbuf);
+
+    if (n_channels == 3)
+        format = CAIRO_FORMAT_RGB24;
+    else
+        format = CAIRO_FORMAT_ARGB32;
+
+    surface = cairo_image_surface_create (format, width, height);
+    if (cairo_surface_status (surface) != CAIRO_STATUS_SUCCESS) {
+        cairo_surface_destroy (surface);
+        return NULL;
+    }
+
+    cairo_pixels = cairo_image_surface_get_data (surface);
+    cairo_rowstride = cairo_image_surface_get_stride (surface);
+
+    if (n_channels == 3) {
+        for (j = height; j; j--) {
+            guchar *p = gdk_pixels;
+            guchar *q = cairo_pixels;
+            guchar *end = p + 3 * width;
+
+            while (p < end) {
+#if G_BYTE_ORDER == G_LITTLE_ENDIAN
+                q[0] = p[2];
+                q[1] = p[1];
+                q[2] = p[0];
+#else
+                q[1] = p[0];
+                q[2] = p[1];
+                q[3] = p[2];
+#endif
+                p += 3;
+                q += 4;
+            }
+
+            gdk_pixels += gdk_rowstride;
+            cairo_pixels += cairo_rowstride;
+        }
+    } else {
+        for (j = height; j; j--) {
+            guchar *p = gdk_pixels;
+            guchar *q = cairo_pixels;
+            guchar *end = p + 4 * width;
+            guint t1, t2, t3;
+
+#define MULT(d,c,a,t) G_STMT_START { t = c * a + 0x7f; d = ((t >> 8) + t) >> 8; } G_STMT_END
+
+            while (p < end) {
+#if G_BYTE_ORDER == G_LITTLE_ENDIAN
+                MULT (q[0], p[2], p[3], t1);
+                MULT (q[1], p[1], p[3], t2);
+                MULT (q[2], p[0], p[3], t3);
+                q[3] = p[3];
+#else
+                q[0] = p[3];
+                MULT (q[1], p[0], p[3], t1);
+                MULT (q[2], p[1], p[3], t2);
+                MULT (q[3], p[2], p[3], t3);
+#endif
+
+                p += 4;
+                q += 4;
+            }
+
+#undef MULT
+            gdk_pixels += gdk_rowstride;
+            cairo_pixels += cairo_rowstride;
+        }
+    }
+
+    cairo_surface_mark_dirty (surface);
+    return surface;
+}
+
+/* Copied from gtk+/gdk/gdkpixbuf-drawable.c, LGPL 2+.
+ *
+ * Copyright (C) 1999 Michael Zucchi
+ *
+ * Authors: Michael Zucchi <zucchi@zedzone.mmc.com.au>
+ *          Cody Russell <bratsche@dfw.net>
+ *          Federico Mena-Quintero <federico@gimp.org>
+ */
+
+static void
+convert_alpha (guchar *dest_data,
+               int     dest_stride,
+               guchar *src_data,
+               int     src_stride,
+               int     src_x,
+               int     src_y,
+               int     width,
+               int     height)
+{
+    int x, y;
+
+    src_data += src_stride * src_y + src_x * 4;
+
+    for (y = 0; y < height; y++) {
+        guint32 *src = (guint32 *) src_data;
+
+        for (x = 0; x < width; x++) {
+          guint alpha = src[x] >> 24;
+
+          if (alpha == 0) {
+              dest_data[x * 4 + 0] = 0;
+              dest_data[x * 4 + 1] = 0;
+              dest_data[x * 4 + 2] = 0;
+          } else {
+              dest_data[x * 4 + 0] = (((src[x] & 0xff0000) >> 16) * 255 + alpha / 2) / alpha;
+              dest_data[x * 4 + 1] = (((src[x] & 0x00ff00) >>  8) * 255 + alpha / 2) / alpha;
+              dest_data[x * 4 + 2] = (((src[x] & 0x0000ff) >>  0) * 255 + alpha / 2) / alpha;
+          }
+          dest_data[x * 4 + 3] = alpha;
+      }
+
+      src_data += src_stride;
+      dest_data += dest_stride;
+    }
+}
+
+static void
+convert_no_alpha (guchar *dest_data,
+                  int     dest_stride,
+                  guchar *src_data,
+                  int     src_stride,
+                  int     src_x,
+                  int     src_y,
+                  int     width,
+                  int     height)
+{
+    int x, y;
+
+    src_data += src_stride * src_y + src_x * 4;
+
+    for (y = 0; y < height; y++) {
+        guint32 *src = (guint32 *) src_data;
+
+        for (x = 0; x < width; x++) {
+            dest_data[x * 3 + 0] = src[x] >> 16;
+            dest_data[x * 3 + 1] = src[x] >>  8;
+            dest_data[x * 3 + 2] = src[x];
+        }
+
+        src_data += src_stride;
+        dest_data += dest_stride;
+    }
+}
+
+GdkPixbuf *
+rsvg_cairo_surface_to_pixbuf (cairo_surface_t *surface)
+{
+    cairo_content_t content;
+    GdkPixbuf *dest;
+    int width, height;
+
+    /* General sanity checks */
+    g_assert (cairo_surface_get_type (surface) == CAIRO_SURFACE_TYPE_IMAGE);
+
+    width = cairo_image_surface_get_width (surface);
+    height = cairo_image_surface_get_height (surface);
+    if (width == 0 || height == 0)
+        return NULL;
+
+    content = cairo_surface_get_content (surface) | CAIRO_CONTENT_COLOR;
+    dest = gdk_pixbuf_new (GDK_COLORSPACE_RGB,
+                          !!(content & CAIRO_CONTENT_ALPHA),
+                          8,
+                          width, height);
+
+    if (gdk_pixbuf_get_has_alpha (dest))
+      convert_alpha (gdk_pixbuf_get_pixels (dest),
+                    gdk_pixbuf_get_rowstride (dest),
+                    cairo_image_surface_get_data (surface),
+                    cairo_image_surface_get_stride (surface),
+                    0, 0,
+                    width, height);
+    else
+      convert_no_alpha (gdk_pixbuf_get_pixels (dest),
+                        gdk_pixbuf_get_rowstride (dest),
+                        cairo_image_surface_get_data (surface),
+                        cairo_image_surface_get_stride (surface),
+                        0, 0,
+                        width, height);
+
+    return dest;
+}
+
+/* This is unused but still exists for ABI compat. See bug #666868. */
+void rsvg_cairo_to_pixbuf (guint8 * pixels, int rowstride, int height);
+
 void
 rsvg_cairo_to_pixbuf (guint8 * pixels, int rowstride, int height)
 {
@@ -1127,29 +1163,3 @@ rsvg_cairo_to_pixbuf (guint8 * pixels, int rowstride, int height)
         }
     }
 }
-
-void
-rsvg_pixbuf_to_cairo (guint8 * pixels, int rowstride, int height)
-{
-    int row;
-    /* un-premultiply data */
-    for (row = 0; row < height; row++) {
-        guint8 *row_data = (pixels + (row * rowstride));
-        int i;
-
-        for (i = 0; i < rowstride; i += 4) {
-            guint32 *b = (guint32 *) & row_data[i];
-            guint8 pixel[4];
-            int alpha;
-
-            memcpy (&pixel, b, sizeof (guint32));
-            alpha = pixel[3];
-            if (alpha == 0)
-                *b = 0;
-            else
-                *b = alpha << 24 |
-                    (int) pixel[0] * alpha / 255 << 16 |
-                    (int) pixel[1] * alpha / 255 << 8 | (int) pixel[2] * alpha / 255;
-        }
-    }
-}
